<template>
  <div
    class="w-screen h-screen pt-32 pl-32 pr-24 pb-20 overflow-visible bg-03 bg-contain"
  >
    <div class="w-full h-full">
      <div
        class="flex h-16 w-full pointer-event-none justify-center items-center"
      >
        <nav aria-label="Progress">
          <ol
            class="border border-gray-300 rounded-md divide-y divide-gray-300 md:flex md:divide-y-0"
          >
            <li class="relative md:flex-1 md:flex">
              <span class="group flex items-center w-full">
                <span class="px-6 py-2 flex items-center text-sm font-medium">
                  <span
                    :class="
                      currentStep === 1 || steps[0].fullfilled
                        ? 'bg-tek-main'
                        : 'bg-tek-white border-2 border-gray-300'
                    "
                    class="flex-shrink-0 w-10 h-10 flex items-center justify-center rounded-full"
                  >
                    <!-- Heroicon name: check -->
                    <svg
                      v-if="steps[0].fullfilled"
                      class="w-6 h-6 text-white"
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 20 20"
                      fill="currentColor"
                      aria-hidden="true"
                    >
                      <path
                        fill-rule="evenodd"
                        d="M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z"
                        clip-rule="evenodd"
                      />
                    </svg>
                    <span
                      v-else
                      :class="
                        currentStep === 1 || steps[0].fullfilled
                          ? 'text-tek-white'
                          : 'text-gray-400'
                      "
                      class="text-gray-400"
                    >
                      01
                    </span>
                  </span>
                  <span
                    :class="
                      currentStep === 1 || steps[0].fullfilled
                        ? 'text-tek-main'
                        : 'text-gray-400'
                    "
                    class="ml-4 text-sm font-medium text-tek-white"
                  >
                    {{ steps[0].title }}
                  </span>
                </span>
              </span>

              <div
                class="hidden md:block absolute top-0 right-0 h-full w-5"
                aria-hidden="true"
              >
                <svg
                  class="h-full w-full text-gray-300"
                  viewBox="0 0 22 80"
                  fill="none"
                  preserveAspectRatio="none"
                >
                  <path
                    d="M0 -2L20 40L0 82"
                    vector-effect="non-scaling-stroke"
                    stroke="currentcolor"
                    stroke-linejoin="round"
                  />
                </svg>
              </div>
            </li>

            <li class="relative md:flex-1 md:flex">
              <!-- Current Step -->
              <span class="px-6 py-2 flex items-center text-sm font-medium">
                <span
                  :class="
                    currentStep === 2 || steps[1].fullfilled
                      ? 'bg-tek-main'
                      : 'bg-tek-white border-2 border-gray-300'
                  "
                  class="flex-shrink-0 w-10 h-10 flex items-center justify-center rounded-full"
                >
                  <!-- Heroicon name: check -->
                  <svg
                    v-if="steps[1].fullfilled"
                    class="w-6 h-6 text-white"
                    xmlns="http://www.w3.org/2000/svg"
                    viewBox="0 0 20 20"
                    fill="currentColor"
                    aria-hidden="true"
                  >
                    <path
                      fill-rule="evenodd"
                      d="M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z"
                      clip-rule="evenodd"
                    />
                  </svg>
                  <span
                    v-else
                    :class="
                      currentStep === 2 || steps[1].fullfilled
                        ? 'text-tek-white'
                        : 'text-gray-400'
                    "
                    class="text-gray-400"
                  >
                    02
                  </span>
                </span>
                <span
                  :class="
                    currentStep === 2 || steps[1].fullfilled
                      ? 'text-tek-main'
                      : 'text-gray-400'
                  "
                  class="ml-4 text-sm font-medium text-tek-white"
                >
                  {{ steps[1].title }}
                </span>
              </span>

              <div
                class="hidden md:block absolute top-0 right-0 h-full w-5"
                aria-hidden="true"
              >
                <svg
                  class="h-full w-full text-gray-300"
                  viewBox="0 0 22 80"
                  fill="none"
                  preserveAspectRatio="none"
                >
                  <path
                    d="M0 -2L20 40L0 82"
                    vector-effect="non-scaling-stroke"
                    stroke="currentcolor"
                    stroke-linejoin="round"
                  />
                </svg>
              </div>
            </li>

            <li class="relative md:flex-1 md:flex">
              <!-- Upcoming Step -->
              <span class="group flex items-center">
                <span class="px-6 py-2 flex items-center text-sm font-medium">
                  <span
                    :class="
                      currentStep === 3 || steps[2].fullfilled
                        ? 'bg-tek-main'
                        : 'bg-tek-white border-2 border-gray-300'
                    "
                    class="flex-shrink-0 w-10 h-10 flex items-center justify-center rounded-full"
                  >
                    <!-- Heroicon name: check -->
                    <svg
                      v-if="steps[2].fullfilled"
                      class="w-6 h-6 text-white"
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 20 20"
                      fill="currentColor"
                      aria-hidden="true"
                    >
                      <path
                        fill-rule="evenodd"
                        d="M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z"
                        clip-rule="evenodd"
                      />
                    </svg>
                    <span
                      v-else
                      :class="
                        currentStep === 3 || steps[2].fullfilled
                          ? 'text-tek-white'
                          : 'text-gray-400'
                      "
                      class="text-gray-400"
                    >
                      03
                    </span>
                  </span>
                  <span
                    :class="
                      currentStep === 3 || steps[2].fullfilled
                        ? 'text-tek-main'
                        : 'text-gray-400'
                    "
                    class="ml-4 text-sm font-medium text-tek-white"
                  >
                    {{ steps[2].title }}
                  </span>
                </span>
              </span>
            </li>
          </ol>
        </nav>
      </div>
      <div class="flex w-full h-5/6 pt-5">
        <div class="w-8/12 pr-3 pl-12 h-full text-tek-white">
          <div v-if="currentStep === 1" class="h-full">
            <h3 class="text-3xl font-medium mb-10">
              Panier ({{ cart.length }})
            </h3>
            <div class="overflow-y-scroll h-full">
              <ItemCardComponent
                v-for="(c, i) in cart"
                :key="i"
                :isBox="c.isBox"
                :item="c"
                isCart
                class="mb-6"
              />
            </div>
          </div>
          <div v-else-if="currentStep === 2" class="text-tek-black h-full">
            <h3 class="text-3xl font-medium mb-10 text-tek-white">
              Livraison
            </h3>
            <div class="bg-tek-white p-10 h-full w-full">
              <div class="bg-tek-white flex justify-between h-48 w-full">
                <div>
                  <div>Mon adresse de livraison</div>
                  <textarea v-model="user.addrSend" />
                </div>
                <div>
                  <div>Mon addresse de facturation</div>
                  <p>{{ sameAddr ? user.addrSend : user.addrFact }}</p>
                </div>
              </div>
              <div class="mb-10">
                <input
                  type="checkbox"
                  name="same"
                  id="same"
                  v-model="sameAddr"
                />
                <label for="same">
                  Utiliser la même adresse pour la livraison et facturation
                </label>
              </div>
              <div class="font-bold mb-5">Mode de livraison</div>
              <div class="flex justify-between items-center">
                <span>A domicile</span>
                <span class="text-tek-main">Livré sous 4-5 jours ouvrés</span>
                <span>5.00 €</span>
                <input name="send" type="radio" checked />
              </div>
              <hr
                class="w-full border-t-2 border-dashed my-5 border-tek-black"
              />
              <div class="flex justify-between items-center">
                <span>Express</span>
                <span class="text-tek-main">Livré sous 1-2 jours ouvrés</span>
                <span>8.50 €</span>
                <input name="send" type="radio" />
              </div>
              <hr
                class="w-full border-t-2 border-dashed my-5 border-tek-black"
              />
              <div class="flex justify-between items-center">
                <span>Point relais</span>
                <span class="text-tek-main">Livré sous 4-5 jours ouvrés</span>
                <span>3.99 €</span>
                <input name="send" type="radio" />
              </div>
            </div>
          </div>
          <div v-else class="h-full relative">
            <h3 class="text-3xl font-medium mb-10">
              Paiement
            </h3>
            <div
              class="bg-tek-white text-tek-black flex flex-col p-12 justify-center items-center h-full"
            >
              <div class="flex w-full justify-between items-center">
                <label class="flex justify-evenly items-center">
                  <i class="fab fa-cc-paypal fa-3x text-tek-black"></i>
                  <span class="ml-10">Paiment par Paypal</span>
                </label>
                <input name="pay" type="radio" checked />
              </div>
              <hr
                class="w-4/5 border-t-2 border-dashed my-5 border-tek-black"
              />
              <div class="flex w-full justify-between items-center">
                <label class="flex justify-evenly items-center">
                  <i class="fab fa-cc-mastercard fa-3x text-tek-black"></i>
                  <span class="ml-10">Paiment par carte MasterCard</span>
                </label>
                <input name="pay" type="radio" />
              </div>
              <hr
                class="w-4/5 border-t-2 border-dashed my-5 border-tek-black"
              />
              <div class="flex w-full justify-between items-center">
                <label for="pay" class="flex justify-evenly items-center">
                  <i class="fab fa-cc-visa fa-3x text-tek-black"></i>
                  <span class="ml-10">Paiment par carte Visa</span>
                </label>
                <input name="pay" type="radio" />
              </div>
            </div>
            <div class="flex w-full items-center justify-between absolute bottom-1 px-16">
              <button
              @click="pay()"
                class="bg-tek-main w-auto mx-2 text-tek-white inline-flex justify-center items-center px-4 py-2 text-md font-semibold"
              >
                Payer
              </button>
              <button
              @click="reset()"
                class="bg-tek-main w-auto mx-2 text-tek-white inline-flex justify-center items-center px-4 py-2 text-md font-semibold"
              >
                Abandonner
              </button>
            </div>
          </div>
        </div>
        <div class="w-4/12 flex flex-col h-full text-tek-white">
          <h3 class="text-3xl font-medium mb-10">Récapitulatif</h3>
          <div class="w-full h-full text-lg p-12 bg-tek-white text-tek-black">
            <ul>
              <li
                class="flex font-semibold mb-5 w-full justify-between items-center"
              >
                <span>Panier ({{ cart.length }})</span>
                <span>{{ cartTotal }} €</span>
              </li>
              <li
                v-for="(it, idx) in cart"
                :key="idx"
                class="flex w-full justify-between items-center"
              >
                <span>{{ it.title }}</span>
                <span>{{ it.price }} €</span>
              </li>
            </ul>
            <hr class="w-full border-t-2 border-dashed my-5 border-tek-black" />
            <span class="flex w-full justify-between items-center">
              <span>Frais de livraison estimés</span>
              <span>3.99 €</span>
            </span>
            <hr class="w-full border-t-2 border-dashed my-5 border-tek-black" />
            <span class="flex w-full justify-between items-center">
              <span>
                Total
                <span class="text-gray-400">(TVA incluse)</span>
              </span>
              <span>{{ commandTotal }} €</span>
            </span>
            <div class="pt-12" v-if="currentStep===3">
                <div>Adresse de Livraison</div>
                <p>{{user.addrSend}}</p>
            </div>
            <div class="w-full h-auto mt-20 flex items-center justify-center"  v-if="currentStep !=3">
              <button
                type="button"
                @click="next()"
                class="bg-tek-main w-auto mx-2 text-tek-white inline-flex justify-center items-center px-4 py-2 text-md font-semibold"
              >
                Valider le panier
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-if="paid" class="rounded-md fade bg-green-50 p-4 absolute top-32 right-6">
  <div class="flex">
    <div class="flex-shrink-0">
      <!-- Heroicon name: check-circle -->
      <svg class="h-5 w-5 text-green-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
        <path fill-rule="evenodd" d="M10 18a8 8 0 100-16 8 8 0 000 16zm3.707-9.293a1 1 0 00-1.414-1.414L9 10.586 7.707 9.293a1 1 0 00-1.414 1.414l2 2a1 1 0 001.414 0l4-4z" clip-rule="evenodd" />
      </svg>
    </div>
    <div class="ml-3">
      <h3 class="text-sm font-medium text-green-800">
          Commande payée avec succès
      </h3>
      <div class="mt-2 text-sm text-green-700">
        <p>
          Lorem ipsum dolor sit amet consectetur adipisicing elit. Aliquid pariatur, ipsum similique veniam.
        </p>
      </div>
    </div>
  </div>
</div>
  </div>
</template>

<script>
import Layout from '@/Shared/Layout'
import ItemCardComponent from '@/Components/shop/ItemCardComponent'
import {EventBus} from '@/event-bus.js'
export default {
  layout: Layout,
  components: { ItemCardComponent },
  data() {
    return {
      steps: [
        { fullfilled: false, title: 'Résumé de la commande' },
        { fullfilled: false, title: 'Adresse de livraison' },
        { fullfilled: false, title: 'Paiement' },
      ],
      currentStep: 1,
      user: this.$page.props.auth.user,
      sameAddr: true,
      paid:false,
      cart: [
        {
          isBox: true,
          title: 'Box arduino',
          price: 45,
          stock: 60,
          desc: 'lorem ipsum dolor amet consedir.',
        },
        {
          isBox: false,
          title: 'Cable SATA',
          price: 20.99,
          q: 3,
          stock: 10040,
          desc: 'lorem ipsum dolor amet consedir.',
        },
        {
          isBox: true,
          title: 'Box Drone',
          price: 60,
          stock: 20,
          desc: 'lorem ipsum dolor amet consedir.',
        },
      ],
    }
  },
  mounted() {
    console.log(this.user)
  },
  computed: {
    cartTotal() {
      return this.cart.reduce((acc, v) => acc + v.price, 0).toFixed(2)
    },
    commandTotal() {
      return this.cart.reduce((acc, v) => acc + v.price, 3.99).toFixed(2)
    },
  },
  methods: {
    next() {
      if (this.currentStep === 3) return
      this.steps[this.currentStep - 1].fullfilled = true
      this.currentStep++
    },
    back() {
      if (this.currentStep === 1) return
      this.steps[this.currentStep - 1].fullfilled = false
      this.currentStep--
    },
    reset(){
    this.steps.forEach(s=>s.fullfilled = false)
      this.currentStep = 1
    },
    pay(){
        this.paid = true
        setTimeout(()=>{this.paid = false},1500)
    }
  },
  created(){
      EventBus.$on('delete', (id)=>{this.cart.splice(id,1)})
  }
}
</script>
